/********************************************
 Computeremuzone Games Studio presenta...

 ============================================
 PHANTOMASA IN THE LAND OF THE GRUNGE WIZARDS
 (v. 2.0) 128K!
 ============================================

  By The Mojon Twins [Anjuel WYZ & na_th_an]
 
 Concepto: na_th_an & anjuel
 Grficos: na_th_an & anjuel
 Programa: na_th_an
 Msica & player: WYZ

 (C) The Mojon Twins - CEZGS 2007
 ********************************************/
#include <spritepack.h>

/* Extern pointers for the graphic definitions: */

#include "externs.h"

/* Allocate space for the stack */

#pragma output STACKPTR=24000

/* Addresses */

#define AD_FREE			25000
//60508

/* Game constants */

#define WYZ_INTERRUPT	$C021	// INICIO	
#define WYZ_LOAD		$C05E	// CARGA_CANCION	
#define WYZ_PLAY_SOUND	$C364	// INICIA_EFECTO
#define WYZ_TATEQUIETOR $C043	// SILENCIA_PLAYER

#define PUCRUNCH		32463

#define MARCO			31483
#define TITLE			30503
#define	FINAL			29507
#define CREDITOS		28340
#define MOJONTWINS		27947

/*
	38000	21909	Código, gráficos, mapa, splib2.
	37461	539		Uncrunch
	36481	980		marco.bin
	35497	984		title.bin
*/

char play = 0;

void SetRAMBank()
{
	#asm   
		.SetRAMBank
		ld  A, ($5B5C)
		and F8h
		or  B
		ld  BC, $7FFD
		ld  ($5B5C), A
		out (C), A
	#endasm
}

#asm
defw 0                        /* two free bytes before start of a hook */
#endasm

void musicISR(void)
{
	if (play)
	{
	#asm
		ld b, 1
		call SetRAMBank
			
		push af
		push bc
		push de
		push hl
		push ix

		call WYZ_INTERRUPT

		pop ix
		pop hl
		pop de
		pop bc
		pop af
		
		ld b, 0
		call SetRAMBank
	#endasm
	}
}

void stop_ay (void)
{
	// Hay que acordarse de paginar antes y despus.
	
	#asm
		di
		ld b,1
		call SetRAMBank
		
		call WYZ_TATEQUIETOR
		
		ld b,0
		call SetRAMBank
		ei
	#endasm
	play = 0;
}

/* Import sp_ClipStruct */

extern struct sp_Rect *sp_ClipStruct;

#asm
	LIB SPCClipStruct
._sp_ClipStruct
	defw SPCClipStruct
#endasm

extern char asm_number[1];
extern char *Rand8;
#asm
	._asm_number defb 0
#endasm

struct sp_Rect spritesClipValues;
struct sp_Rect *spritesClip;

/* Manage keys and joystick at the same time: */

struct sp_UDK keys;

/* Create memory allocator for sprite routines */

void *my_malloc(uint bytes)
{
   return sp_BlockAlloc(0);
}

void *u_malloc = my_malloc;
void *u_free = sp_FreeBlock;

/* Strings printed during the game */

struct sp_PSS ps;         /* a print string struct used by sp_PrintString */

/* Data types */

// Estructura de datos para Phantomasa.

typedef struct
{
	int x, y;
	int vx, vy;
	char g, ax, rx;
	uchar salto, cont_salto;
	uchar *current_frame, *next_frame;
	uchar saltando;
	uchar frame, subframe, facing;
	int life;
	char gold;
	uchar atr;
	uchar ctfall;
	uchar ct;
	uchar estado;
} INERCIA;

INERCIA phasa;
struct sp_SS *sp_phasa;

// Estructura de datos para los objetos móviles:

typedef struct
{
	uchar x, y;
	char vx, vy;
	// uchar t1, t2;
	int rx, ry;
	uchar *current_frame, *next_frame;
	uchar maxv;
	uchar a;
} MOVILES;

MOVILES moviles[2];
struct sp_SS *sp_moviles [2];
struct sp_SS *sp_estalactita;

// Estructura de datos para los objetos que hay que coger:

typedef struct
{
	uchar x, y;
	uchar status;
} PA_COGER;

PA_COGER nineros [50] = {
	{16, 10,1},		{22, 18, 1},	{14, 8, 1},		{18, 18, 1},	{14, 18, 1},
	{12, 10,1},		{14, 10, 1},	{16, 10,1},		{8, 14, 1},		{8, 4, 1},
	{20, 12, 1},	{16, 18, 1},	{20, 14, 1},	{12, 4, 1},		{24, 10, 1}, 
	{4, 10, 1}, 	{12, 4, 1}, 	{14, 6, 1}, 	{10, 10, 1}, 	{26, 4, 1}, 
	{4, 8, 1}, 		{26, 8, 1}, 	{26, 8, 1}, 	{4, 10, 1}, 	{26, 4, 1}, 
	{4, 6, 1}, 		{14, 2, 1}, 	{10, 12, 1}, 	{8, 4, 1}, 		{18, 14, 1}, 
	{4, 16, 1}, 	{22, 14, 1}, 	{12, 18, 1}, 	{6, 4, 1}, 		{24, 10, 1}, 	
	{10, 10, 1},	{4, 16, 1}, 	{16, 12, 1},	{8, 12, 1},		{16, 12, 1}, 	
	{6, 18, 1},		{22, 16, 1},	{12, 16, 1},	{18, 14, 1},	{20, 16, 1}, 
	{6, 16, 1},		{16, 16, 1},	{26, 10, 1},	{8, 16, 1},		{18, 16, 1}
};

// Estructura de datos para la lava que se mueve

typedef struct
{
	uchar x, y;
} BLUOB_BLUOB;

BLUOB_BLUOB lava [10];
char maxlava;

// Energía extra que aparece destrangis:

uchar energ_x, energ_y, energ_s, energ_p, energ_t; 

// Estructura para la Estalactita Coñaso

typedef struct
{
	uchar a, x, y, l;
} QUE_CARAJASO;

QUE_CARAJASO est_pesa;

// Fin de las estructuras de datos :)

int offsetscreen;

/* WYZ music & sound calls */

void wyz_play_sound (char fx_number)
{
	// Hay que acordarse de paginar antes y despus.
	
	asm_number[0] = fx_number;
	#asm
		di
		ld b,1
		call SetRAMBank
		
		ld c, 2
		ld a, (_asm_number)
		ld b, a
		call WYZ_PLAY_SOUND
		
		ld b,0
		call SetRAMBank
		ei
	#endasm
}

void wyz_play_song (char song_number)
{
	// Hay que acordarse de paginar antes y despus.
	
	play = 0;
	asm_number[0] = song_number;
	#asm
		di
		ld b,1
		call SetRAMBank
	
		ld a, (_asm_number)
		call WYZ_LOAD
		
		ld b,0
		call SetRAMBank
		ei
	#endasm
	play = 1;
}

/* Auxiliary functions */

void fade_out () 
{ 
	int i;
	
	/* El segundo programa de más de 5 lineas en Z80 ASM de na_th_an */ 
	/* Optimizado por Metalbrain */ 
	/* Esto "oscurece" un paso la pantalla. Llamado 8 veces la dejará en negro */ 

	for (i = 0; i < 8; i ++) {
		#asm 
		  ld  e, 3            ; 3 tercios 
		  ld  hl, 22528       ; aquí empiezan los atributos 
		  halt                ; esperamos retrazo. 
		.fade_out_bucle 
		  ld  a, (hl)         ; nos traemos el atributo actual 
		
		  ld  d, a            ; tomar atributo 
		  and  7              ; aislar la tinta 
		  jr  z, ink_done     ; si vale 0, no se decrementa 
		  dec  a              ; decrementamos tinta 
		.ink_done 
		  ld  b, a            ; en b tenemos ahora la tinta ya procesada. 
		
		  ld  a, d            ; tomar atributo 
		  and  56             ; aislar el papel, sin modificar su posición en el byte 
		  jr  z, paper_done   ; si vale 0, no se decrementa 
		  sub 8               ; decrementamos papel restando 8 
		.paper_done 
		  ld  c, a            ; en c tenemos ahora el papel ya procesado. 
		  ld  a, d 
		  and  192            ; nos quedamos con bits 6 y 7 (BRIGHT y FLASH) 
		  or  c               ; añadimos paper 
		  or  b               ; e ink, con lo que recompuesto el atributo 
		  ld  (hl),a          ; lo escribimos, 
		  inc  l              ; e incrementamos el puntero. 
		  jr  nz, fade_out_bucle ; continuamos hasta acabar el tercio (cuando L valga 0) 
		  inc  h              ; siguiente tercio 
		  dec  e 
		  jr  nz, fade_out_bucle ; repetir las 3 veces 
		#endasm 
	}
}

uchar rand ()
{
	uchar res;

#asm
._Rand8	ld	a,0		; Seed is usually 0
		ld	b,a
		add	a,a
		add	a,a
		add	a,b
		inc	a		; another possibility is ADD A,7
		ld (_Rand8+1),a
		ld (_asm_number), a
#endasm

	res = asm_number [0];

	return res;
}

int sgn (int x)
{
	if (x < 0)
		return -1;
	else if (x = 0)
		return 0;
	else
		return 1;
}

//#define sgn (x)		(x) < 0 ? -1 : (x) = 0 ? 0 : 1

unsigned int abs (int x)
{
	if (x >= 0)
		return x;
	else
		return -x;
}

//#define abs (x)		(x) >= 0 ? (x) : - (x)

unsigned char attr (char x, char y)
{
	char *res = (char *) (22528 + x + (y << 5));
	return (*res & 63);
}

void draw_tile_c (char x, char y, char tile)
{
	uchar basetile = tile << 2;

	sp_PrintAtInv (y, x, attrs [basetile], basetile + 7);
	sp_PrintAtInv (y, x + 1, attrs [basetile + 1], basetile + 8);
	sp_PrintAtInv (y + 1, x, attrs [basetile + 2], basetile + 9);
	sp_PrintAtInv (y + 1, x + 1, attrs [basetile + 3], basetile + 10);
}

void draw_tile (char x, char y, char c, char tile)
{
	sp_PrintAtInv (y, x, c, tile);
	sp_PrintAtInv (y, 1 + x, c, tile + 1);
	sp_PrintAtInv (1 + y, x, c, tile + 2);
	sp_PrintAtInv (1 + y, 1 + x, c, tile + 3);
}

/* Uncrunch image routine */

void blackout_everything ()
{
	unsigned char *origin;

	origin = (unsigned char *) 22528;
	while (origin < 23296)
	{
		*origin = 0;
		origin ++;
	}
}

void uncrunch (int address)
{
	unsigned char *origin;
	unsigned char *destiny;
	unsigned char msb, lsb;

	origin = (unsigned char *) PUCRUNCH;
	destiny = (unsigned char *) PUCRUNCH + 2;

	msb = address >> 8;
	lsb = address & 255;
	
	*origin = lsb;
	origin ++;
	*origin = msb;

	*destiny = 0;
	destiny ++;
	*destiny = 64;

	// Antes de llamar a pucrunch, tintamos la pantalla de negro
	// para que no se vea tan feo:

	blackout_everything ();

	#asm
		di
		call PUCRUNCH + 4
		ei
	#endasm
}

/* Game functions */

void show_gold ()
{
	sp_PrintAtInv (22, 28, 69, 1 + (phasa.gold / 10));
	sp_PrintAtInv (22, 29, 69, 1 + (phasa.gold % 10));
}

void show_life ()
{
	sp_PrintAtInv (22, 6, 69, 1 + (phasa.life / 100));
	sp_PrintAtInv (22, 7, 69, 1 + ((phasa.life % 100) / 10));
	sp_PrintAtInv (22, 8, 69, 1 + (phasa.life % 10));
}

/*
void show_me(uchar que)
{
	sp_PrintAtInv (0, 0, 69, 1 + (que / 100));
	sp_PrintAtInv (0, 1, 69, 1 + ((que % 100) / 10));
	sp_PrintAtInv (0, 2, 69, 1 + (que % 10));
}
*/

unsigned char move ()
{
	uchar xx, yy;
	uchar x, y;
	uchar i;
	int auxa;

	i = sp_JoyKeyboard (&keys); // Leemos del teclado

	/* Primera prueba del motor de movimiento de inercia para z88dk/splib2
	   Vamos a ver si esto no explota t?*/

	/* Por partes. Primero el movimiento vertical. La ecuaci? de movimien-
	   to viene a ser, en cada ciclo:

	   1.- vy = vy + g
	   2.- y = y + vy

	   O sea la velocidad afectada por la gravedad.
	   Para no colarnos con los nmeros, ponemos limitadores:
	*/
	
	auxa = phasa.vy;

	if (phasa.vy < 511/*256*/)
		phasa.vy += phasa.g;
	else
		phasa.vy = 511/*256*/;

	phasa.y += phasa.vy;

	/* El problema es que no es tan f?il... Hay que ver si no nos chocamos.
	   Si esto pasa, hay que "recular" hasta el borde del obst?ulo.

	   Por eso miramos el signo de vy, para que los c?culos sean m? sencillos.
	   De paso vamos a precalcular un par de cosas para que esto vaya m? r?ido.
	*/

	x = phasa.x >> 6;		// dividimos entre 64 para pixels, y luego entre 8 para tiles.
	y = phasa.y >> 6;
	xx = x >> 3;
	yy = y >> 3;

	if (phasa.vy < 0)		// estamos ascendiendo
	{
		if ((attr (xx, yy) != phasa.atr || attr (xx + 1, yy) != phasa.atr || ((x & 7) != 0 && attr (xx + 2, yy) != phasa.atr)) && yy > 1)
		{
			// paramos y ajustamos:
			phasa.vy = 0;
			phasa.y = (yy + 1) << 9;
		}
	}
	else if (phasa.vy > 0)	// estamos descendiendo
	{
		phasa.ctfall ++;
		if (phasa.ctfall > 192)
			phasa.ctfall = 192;
		if (yy != 20 && (attr (xx, yy + 2) != phasa.atr || attr (xx + 1, yy + 2) != phasa.atr || ((x & 7) != 0 && attr (xx + 2, yy + 2) != phasa.atr)))
		{
			// paramos y ajustamos:
			if (phasa.ctfall < 20)
			{
				if (phasa.vy > 128)
					wyz_play_sound (6);
				phasa.vy = 0;				
			}
			else if ( !phasa.estado )
			{
				phasa.vy = -(phasa.vy) / 2;
				phasa.life -= 25;
				if (phasa.life < 0)
					phasa.life = 0;
				show_life ();
				phasa.ct = 100;
				phasa.estado = 1;
				wyz_play_sound (3);
			}
			phasa.y = yy << 9;
			phasa.ctfall = 0;
		}
	}

	/* Salto: El salto se reduce a dar un valor negativo a vy. Esta es la forma m?
	   sencilla. Sin embargo, para m? control, usamos el tipo de salto "mario bros".
	   Para ello, en cada pulsaci? dejaremos decrementar vy hasta un m?imo, y de-
	   tectando que no se vuelva a pulsar cuando estemos en el aire. Juego de banderas ;)
	*/

	if ( yy != 20 && (i & sp_UP) == 0 && phasa.vy == 0 && phasa.saltando == 0 && (attr (xx, yy + 2) != phasa.atr || attr (xx + 1, yy + 2) != phasa.atr || ((x & 7) != 0 && attr (xx + 2, yy + 2) != phasa.atr)))
	{
		phasa.saltando = 1;
		phasa.cont_salto = 0;
		wyz_play_sound (5);
		
		// Para que el inicio del salto sea m? potente: (a veces conviene):
		// phasa.vy -= (phasa.salto << 1);
	}

	if ( (i & sp_UP) == 0 && phasa.saltando )
	{
		phasa.vy -= (phasa.salto + 48/*16*/ - (phasa.cont_salto>>1));
		if (phasa.vy < -384/*128*/) phasa.vy = -384/*128*/;

		phasa.cont_salto ++;
		if (phasa.cont_salto == 8)
			phasa.saltando = 0;
	}

	if ( (i & sp_UP) != 0 )
		phasa.saltando = 0;
		
	// ----------------------------------------------------------- ok con el movimiento vertical.

	/* Movimiento horizontal:

	   Mientras se pulse una tecla de direcci?,

	   x = x + vx
	   vx = vx + ax

	   Si no se pulsa nada:

	   x = x + vx
	   vx = vx - rx
	*/

	if ( ! ((i & sp_LEFT) == 0 || (i & sp_RIGHT) == 0))
		if (phasa.vx > 0)
		{
			phasa.vx -= phasa.rx;
			if (phasa.vx < 0)
				phasa.vx = 0;
		}
		else if (phasa.vx < 0)
		{
			phasa.vx += phasa.rx;
			if (phasa.vx > 0)
				phasa.vx = 0;
		}

	if ((i & sp_LEFT) == 0)
		if (phasa.vx > -256)
		{
			phasa.facing = 0;
			phasa.vx -= phasa.ax;
		}

	if ((i & sp_RIGHT) == 0)
		if (phasa.vx < 256)
		{
			phasa.vx += phasa.ax;
			phasa.facing = 1;
		}

	phasa.x += phasa.vx;

	/* Ahora, como antes, vemos si nos chocamos con algo, y en ese caso
	   paramos y reculamos */

	y = phasa.y >> 6;
	x = phasa.x >> 6;
	yy = y >> 3;
	xx = x >> 3;

	if (phasa.vx < 0)
	{
		if (yy > 1 && (attr (xx, yy) != phasa.atr || attr (xx, yy + 1) != phasa.atr || ((y & 7) != 0 && attr (xx, yy + 2) != phasa.atr)))
		{
			// paramos y ajustamos:
			phasa.vx = 0;
			phasa.x = (xx + 1) << 9;
		}
	}
	else
	{
		if (yy > 1 && (attr (xx + 2, yy) != phasa.atr || attr (xx + 2, yy + 1) != phasa.atr || ((y & 7) != 0 && attr (xx + 2, yy + 2) != phasa.atr)))
		{
			// paramos y ajustamos:
			phasa.vx = 0;
			phasa.x = xx << 9;
		}
	}

	// Calculamos el frame que hay que poner:

	if (phasa.vy != 0)
	{
		if (phasa.facing == 0)
			phasa.next_frame = phasa_l2a;
		else
			phasa.next_frame = phasa_r2a;
	}
	else
	{
		if (phasa.vx == 0)
		{
			if (phasa.facing == 0)
				phasa.next_frame = phasa_l1a;
			else
				phasa.next_frame = phasa_r1a;
		}
		else
		{
			phasa.subframe ++;
			if (phasa.subframe == 4)
			{
				phasa.subframe = 0;
				phasa.frame = !phasa.frame; // (phasa.frame + 1) & 1;
			}
			if (phasa.facing == 0)
			{
				if (phasa.frame == 0)
					phasa.next_frame = phasa_l1a;
				else
					phasa.next_frame = phasa_l2a;
			}
			else
			{
				if (phasa.frame == 0)
					phasa.next_frame = phasa_r1a;
				else
					phasa.next_frame = phasa_r2a;
			}
		}
	}
}

void move_moviles ()
{
	uchar i;

	for (i = 0; i < 2; i ++)
	{
		if (phasa.x > moviles [i].rx && moviles [i].vx < moviles [i].maxv)
			moviles [i].vx += moviles [i].a;
		else if (phasa.x < moviles [i].rx && moviles [i].vx > -moviles [i].maxv)
			moviles [i].vx -= moviles [i].a;

		if (phasa.y > moviles [i].ry && moviles [i].vy < moviles [i].maxv)
			moviles [i].vy += moviles [i].a;
		else if (phasa.y < moviles [i].ry && moviles [i].vy > -moviles [i].maxv)
			moviles [i].vy -= moviles [i].a;

		moviles [i].rx += moviles [i].vx;
		moviles [i].ry += moviles [i].vy;

		moviles [i].x = (unsigned char) (moviles [i].rx >> 6);
		moviles [i].y = (unsigned char) (moviles [i].ry >> 6);
	}
	
	if ( est_pesa.l )
	{
		if ( !est_pesa.a && (phasa.y >> 9) > 3)
		{
			if ((rand() % 31) == 0)
			{
				est_pesa.y = 0;
				est_pesa.x = (phasa.x >> 9) << 3;
				est_pesa.a = 1;
				wyz_play_sound (1);
			}
		}
		else
		{
			est_pesa.y += 4;
			if (est_pesa.y >= 176)
				est_pesa.a = 0;
		}
	}
}

unsigned char draw_pant (uchar npant)
{
	unsigned int pinpoint = offsetscreen;
	uchar fondopoint = 0;
	uchar i, x, y;
	uchar c, c1, c2, c3, c4;

	maxlava = 0;

	x = 2; y = 2;
	
	if (npant < 10) {
		for ( i = 0; i < 140; i ++ ) {
			sp_PrintAtInv (y, x, 3, 159);
			sp_PrintAtInv (y, 1 + x, 3, 160);
			sp_PrintAtInv (1 + y, x, 3, 161);
			sp_PrintAtInv (1 + y, 1 + x, 3, 162);
			x += 2; if (x == 30) { x = 2; y += 2; }
		}
	} else if (npant < 35) {
		for ( i = 0; i < 140; i ++ ) {
			draw_tile (x, y, 15, 127 + (fondo [fondopoint] << 2));
			x += 2; if (x == 30) { x = 2; y += 2; }
			fondopoint ++;
		}
	} else {
		for ( i = 0; i < 140; i ++ ) {
			if (mapa [pinpoint - 15] != 0) c1 = 4; else c1 = 0;
			if (mapa [pinpoint - 14] != 0) c2 = 4; else c2 = 0;
			if (mapa [pinpoint - 1] != 0) c3 = 4; else c3 = 0;
			sp_PrintAtInv (y, x, 6, 199 + c1);
			sp_PrintAtInv (y, 1 + x, 6, 200 + c2);
			sp_PrintAtInv (1 + y, x, 6, 201 + c3);
			sp_PrintAtInv (1 + y, 1 + x, 6, 202);
			x += 2; if (x == 30) { x = 2; y += 2; }
			pinpoint ++;
		}
	}

	x = 2; y = 2;
	pinpoint = offsetscreen;
		
	for ( i = 0; i < 140; i ++ )
	{
		c = mapa [pinpoint];
		pinpoint ++;

		if (c != 0)
			draw_tile_c (x, y, c);
		

		// Salvamos la posición si el tile es lava.
		// Esto es para animarla luego.

		if (c == 39)
		{	
			lava [maxlava].x = x;
			lava [maxlava].y = y;
			maxlava ++;
		}

		x += 2;
		if (x == 30)
		{
			x = 2;
 			y += 2;
		}
	}
	
	// Pintar monedas:
	
	if (nineros [npant].status == 0)
		draw_tile (nineros [npant].x, nineros [npant].y, 64 + phasa.atr, 155);
}

void setupscreen (uchar pant)
{
	uchar i, j;

	offsetscreen = 140 * pant;
	
	est_pesa.a = 0;
	
	if (pant < 10) {
		est_pesa.l = 1;
		phasa.atr = 3;
	} else if (pant < 35) {
		est_pesa.l = 0;
		phasa.atr = 15;
	} else {
		est_pesa.l = 1;
		phasa.atr = 6;
	}
	
	if (pant < 10 || pant > 34)
		est_pesa.l = 1;
	else
		est_pesa.l = 0;

	sp_MoveSprAbs (sp_phasa, spritesClip, 0, 0,0,0,0);
	
	// Creamos los sprites
	for (i = 0; i < 2; i ++)
	{
		moviles [i].x = 16 + (rand() % 224);
		moviles [i].rx = moviles [i].x << 6;
		moviles [i].y = 16 + (rand() % 144);
		moviles [i].ry = moviles [i].y << 6;
		moviles [i].vx = 0;
		moviles [i].vy = 1;
		moviles [i].maxv = 64 + (rand() & 31);
		moviles [i].a = 4 + (rand() & 3);

		j = rand() & 3;
		switch (j) {
			case 0:
				moviles[i].next_frame = enem1_1a;
				break;
			case 1:
				moviles[i].next_frame = enem2_1a;
				break;
			case 2:
				moviles[i].next_frame = enem3_1a;
				break;
			case 3:
				moviles[i].next_frame = enem4_1a;
		}
				
		sp_MoveSprAbs (sp_moviles [i], spritesClip, moviles [i].next_frame - moviles [i].current_frame, 0,0,0,0);
		moviles [i].current_frame = moviles [i].next_frame;
	}
	
	// 
	
	// Dibujamos la pantalla
	draw_pant (pant);

	// ¿Aparece una energía furtiva?

	// Estas son las condiciones:
	// 1.- Que NO haya una energía por ahí aparecida.
	// 2.- Que un número al azar entre 0 y 7 sea 0.
	
	// Una energía "desaparece" si estamos a más de una
	// pantalla de distancia:
	
	if (energ_s)
	{
		if 	( !((pant >= energ_p - 1 && pant <= energ_p + 1) || (pant >= energ_p - 6 && pant <= energ_p - 4) || (pant >= energ_p + 4 && pant <= energ_p + 6)) )
			energ_s = 0;
	}

	// Si se cumplen las condiciones 1,2 de antes,
	// creamos una nueva energía:
	
	if (!energ_s && (rand() % 7) == 0)
	{
		energ_s = 1;
		energ_p = pant;

		do
		{
			energ_x = 2 + ((rand() % 14) << 1);
			energ_y = 2 + ((rand() % 10) << 1);
		}
		while (mapa [offsetscreen + 14 * ((energ_y - 2) >> 1) + ((energ_x - 2) >> 1)] != 0);

		energ_x = energ_x << 3;
		energ_y = energ_y << 3;
		
		energ_t = rand() & 1;
	}
	
	// Si la energía está activa y estamos en la pantalla
	// propicia...
	
	if (energ_s && energ_p == pant)
		draw_tile (energ_x >> 3, energ_y >> 3, 64 + phasa.atr, 191 + (energ_t << 2));
		
	// Estalactita por siaca.
	
	sp_MoveSprAbs (sp_estalactita, spritesClip, 0, 0,0,0,0);
}

/* Main */

void main (void)
{
	unsigned char j, x, y;
	uchar i;
	char idx;
	unsigned char *wyz_music_flag;
	unsigned char *allpurposepuntero;
	uchar pant;
	uchar playthegame;
	uchar halflife = 0;
	uchar lava_flipflop = 0, lava_counter = 0;
	
	// Ugly pseudorandom seed using the FRAMES sys var

	/* Substitute BASICs ISR for this thingo: */
	#asm
		di
	#endasm

	sp_InitIM2(0xf1f1);						// Does nothing :)
	sp_CreateGenericISR(0xf1f1);
	sp_RegisterHook(255, musicISR);			// Registramos el hook - Gracias Utopian!

	#asm
		ei
	#endasm

	/* Initialization stuff */

	sp_Initialize (7, 0);
	sp_Border (BLACK);
	sp_AddMemory(0, 37, 14, AD_FREE);		// Allocate for 42 blocks of memory (tight!)
	ps.flags  = sp_PSS_INVALIDATE;
    ps.bounds = sp_ClipStruct;

	keys.up    = sp_LookupKey('q');
	keys.down  = sp_LookupKey('a');
	keys.left  = sp_LookupKey('o');
	keys.right = sp_LookupKey('p');
	keys.fire  = sp_LookupKey(' ');

	/* dummy tiles */

	allpurposepuntero = game_tiles;
	for (j = 0; j < 207; j++)
	{
		sp_TileArray (j, allpurposepuntero);
		allpurposepuntero += 8;
	}

	/* Clip structure -- define it as small as possible! */

	spritesClipValues.row_coord = 2;
	spritesClipValues.col_coord = 2;
	spritesClipValues.height = 20;
	spritesClipValues.width = 28;
	spritesClip = &spritesClipValues;

	/* Create sprites */

	sp_phasa = sp_CreateSpr(sp_MASK_SPRITE, 3, phasa_r1a, 1, TRANSPARENT);
	sp_AddColSpr (sp_phasa,  phasa_r1b, TRANSPARENT);
	sp_AddColSpr (sp_phasa, phasa_r1c, TRANSPARENT);
	phasa.next_frame = phasa.current_frame = phasa_r1a;

	sp_moviles [0] = sp_CreateSpr(sp_MASK_SPRITE, 3, enem1_1a, 2, TRANSPARENT);
	sp_AddColSpr (sp_moviles [0], enem1_1b, TRANSPARENT);
	sp_AddColSpr (sp_moviles [0], enem1_1c, TRANSPARENT);
	moviles[0].next_frame = moviles [0].current_frame = enem1_1a;

	sp_moviles [1] = sp_CreateSpr(sp_MASK_SPRITE, 3, enem2_1a, 3, TRANSPARENT);
	sp_AddColSpr (sp_moviles [1], enem2_1b, TRANSPARENT);
	sp_AddColSpr (sp_moviles [1], enem2_1c, TRANSPARENT);
	moviles[1].next_frame = moviles [1].current_frame = enem2_1a;
	
	sp_estalactita = sp_CreateSpr(sp_MASK_SPRITE, 3, estalactita, 4, TRANSPARENT);

	uncrunch (MOJONTWINS);
	sp_Pause (150);
	fade_out ();
	
	while (1)
	{
		// Aquí pantalla de título y esperamos a pulsar una tecla
		
		uncrunch (TITLE);
		wyz_play_song (0);
		
		sp_Pause (32767);
		
		j = 0;
				
		//play = 0;
		stop_ay ();
		
		fade_out ();
		
		sp_ClearRect(sp_ClipStruct, 0, ' ', sp_CR_TILES); 
		sp_UpdateNow();
		uncrunch (MARCO);
		sp_UpdateNow ();

		phasa.x = 208 << 6;
		phasa.y = 128 << 6;
		phasa.vy = 0;
		phasa.g = 48; //32; //8;
		phasa.vx = 0;
		phasa.ax = 24; //8;
		phasa.rx = 32; //8;
		phasa.salto = 96;//64;
		phasa.cont_salto = 1;
		phasa.saltando = 0;
		phasa.frame = 0;
		phasa.subframe = 0;
		phasa.facing = 1;
		phasa.ctfall = 0;
		phasa.ct = 0;
		phasa.estado = 1;
	
		phasa.life = 199;
		phasa.gold = 0;

		phasa.atr = 15;
		
		est_pesa.a = 0;
		
		for (i = 0; i < 50; i ++)
			nineros [i].status = 0;
			
		pant = 30;
		setupscreen (pant);
		show_gold ();
		show_life ();
		
		playthegame = 0;
		wyz_play_song (1);
		
		while (playthegame == 0)
		{
			inibucle:
	
			halflife = !halflife;		// Esto se hace para que solo quite vida cada 2 frames.
										// (quita la mitad de vida = half life :P ).
			sp_UpdateNow();
	
			/* Bluob la lava */
			for (idx = 0; idx < maxlava; idx ++)
				draw_tile_c (lava [idx].x, lava [idx].y, 39 + lava_flipflop);

			lava_counter ++;
			if (lava_counter == 4)
			{
				lava_counter = 0;
				lava_flipflop = !lava_flipflop;
			}
	
			/* Move sprites */
			move ();
			move_moviles ();
			x = phasa.x >> 6;
			y = phasa.y >> 6;
	
			i = sp_JoyKeyboard (&keys); // Leemos del teclado

			/* Connectivity */
			if ((x == 16 && (i & sp_LEFT) == 0) || x < 16)
			{
				pant --;
				setupscreen (pant);
				phasa.x = 224 << 6;
				goto inibucle;
			}
	
			if ((x == 224 && (i & sp_RIGHT) == 0) || x > 224)
			{
				pant ++;
				setupscreen (pant);
				phasa.x = 16 << 6;
				goto inibucle;
			}
	
			if ( y < 16 )
			{
				pant -= 5;
				phasa.y = 158 << 6;
				/*
				if (pant < 10)
					phasa.atr = 3;
				*/
				setupscreen (pant);
				goto inibucle;
			}
	
			if (y >= 160 && !phasa.saltando)
			{
				pant += 5;
				phasa.y = 16 << 6;
				/*
				if (pant > 9)
					phasa.atr = 15;
				*/
				setupscreen (pant);
				goto inibucle;
			}
	
			/* Collisions */
			
			if ( nineros [pant].status == 0 )
				if ( x > (nineros [pant].x << 3) - 15 && x < (nineros [pant].x << 3) + 15 && y > (nineros [pant].y << 3) - 15 && y < (nineros [pant].y << 3) + 15)
				{
					wyz_play_sound(2);
					nineros [pant].status = 1;
					phasa.gold ++;
					if (pant < 10)
						draw_tile (nineros [pant].x, nineros [pant].y, 3, 159);
					else if (pant < 35)
						draw_tile (nineros [pant].x, nineros [pant].y, 15, 127 + (fondo [14 * ((nineros [pant].y - 2) >> 1) + ((nineros [pant].x - 2) >> 1)] << 2));
					else
						draw_tile (nineros [pant].x, nineros [pant].y, 6, 199);
					show_gold ();
					/* phasa.life += 5;
					
					if (phasa.life > 99)
						phasa.life = 99;
						
					show_life ();
					*/
				}
	
			if ( !phasa.estado )
			{
				for ( i = 0; i < 2; i ++ )
				{
					if ( x >= moviles [i].x - 15 && x <= moviles [i].x + 15 && y >= moviles [i].y - 15 && y <= moviles [i].y + 15 && halflife )
					{
						/*
						phasa.x += moviles [i].vx;
						if (phasa.x < 1024)
							phasa.x = 1024;
						phasa.y += moviles [i].vy;
						*/
						
						wyz_play_sound(4);
						
						moviles [i].vx = - (sgn (moviles [i].vx)) * 127;
						moviles [i].vy = - (sgn (moviles [i].vy)) * 127;
						moviles [i].rx += moviles [i].vx;
						moviles [i].ry += moviles [i].vy;
						moviles [i].x = moviles [i].rx >> 6;
						moviles [i].y = moviles [i].ry >> 6;
						phasa.life --; if (phasa.life < 0) phasa.life = 0;
						show_life ();
					}
				}
				
				if ( energ_p == pant && energ_s && x > energ_x - 15 && x < energ_x + 15 && y > energ_y - 15 && y < energ_y + 15)
				{
					wyz_play_sound(2);
					
					energ_s = 0;
					energ_x = energ_x >> 3;
					energ_y = energ_y >> 3;
					if (pant < 10)
						draw_tile (energ_x, energ_y, 3, 159);
					else if (pant < 35)
						draw_tile (energ_x, energ_y, 15, 127 + (fondo [14* ((energ_y - 2) >> 1) + ((energ_x - 2) >> 1)] << 2));
					else
						draw_tile (energ_x, energ_y, 6, 199);
						
					if ( energ_t == 0 )
					{
						phasa.life += 25;
					}
					else
					{
						phasa.estado = 1;
						phasa.ct = 500;
						phasa.life += 10;
					}
					
					if (phasa.life > 199)
						phasa.life = 199;
					show_life ();
				}
	
				if ( mapa [offsetscreen + 14 * (((y - 16) >> 4) + 1) + ((x - 16) >> 4)] == 39 )
				{
					wyz_play_sound(4);
					phasa.life --;
					show_life ();
				}
				
				if ( est_pesa.a && x >= est_pesa.x - 15 && x <= est_pesa.x + 7 && y >= est_pesa.y - 15 && y <= est_pesa.y + 15 )
				{
					wyz_play_sound(5);
					est_pesa.a = 0;
					phasa.vy -= phasa.salto;
					phasa.life -= 2;
					if (phasa.life < 0)
						phasa.life = 0;
					show_life ();
					phasa.estado = 1;
					sp_MoveSprAbs (sp_estalactita, spritesClip, 0, 0,0,0,0);
				}
			}
			
			/* Finish him */
			
			if ( phasa.gold == 50 )
				playthegame = 1;		// Game over bueno.
				
			if ( phasa.life <= 0 )
				playthegame = 2;		// Game over malo
				
			if ( phasa.ct > 0 )
				phasa.ct --;
			else
				phasa.estado = 0;
	
			/* Render */

			if (!phasa.estado || (phasa.estado && halflife))
			{
				sp_MoveSprAbs (sp_phasa, spritesClip, phasa.next_frame - phasa.current_frame, y >> 3, x >> 3, x & 7, y & 7);
				phasa.current_frame = phasa.next_frame;
			}
			else
				sp_MoveSprAbs (sp_phasa, spritesClip, 0, 0,0,0,0);
	
			for ( i = 0; i < 2; i ++ )
			{
				sp_MoveSprAbs (sp_moviles [i], spritesClip, 0/*moviles [i].next_frame - moviles [i].current_frame*/, moviles [i].y >> 3, moviles [i].x >> 3, moviles [i].x & 7, moviles [i].y & 7);
				// moviles [i].current_frame = moviles [i].next_frame;
			}
			
			if ( est_pesa.a )
				sp_MoveSprAbs (sp_estalactita, spritesClip, 0, est_pesa.y >> 3, est_pesa.x >> 3, est_pesa.x & 7, est_pesa.y & 7);
		}
		
		stop_ay ();
				
		if (playthegame == 1)
		{
			fade_out ();
		
			// Gameover bueno: mostrar pantalla final.
			uncrunch (FINAL);
			wyz_play_song (2);
			sp_Pause (1000);
			fade_out ();
			uncrunch (CREDITOS);
			sp_Pause (1000);
		}
		else
		{
			// Gameover malo: mostrar "game over".

			sp_MoveSprAbs (sp_moviles [0], spritesClip, 0, 0,0,0,0);
			sp_MoveSprAbs (sp_moviles [1], spritesClip, 0, 0,0,0,0);
			sp_MoveSprAbs (sp_phasa, spritesClip, 0, 0,0,0,0);
			sp_MoveSprAbs (sp_estalactita, spritesClip, 0, 0,0,0,0);
			sp_UpdateNow ();
			
			fade_out ();
			
			blackout_everything ();

			for (i = 11; i < 21; i ++)
			{
				sp_PrintAtInv (10, i, 70, i + 160);
				sp_PrintAtInv (11, i, 66, i + 170);
			}

			sp_UpdateNow ();

			sp_Pause (1000);
		}
		
		stop_ay ();
		play = 0;

		fade_out ();			
	}
}

// Data!!!

#include "sprites.h"
#include "mapa.h"
#include "tiles.h"

